/*
 * audio_decoder_mp3_http.c: The mp3 decoder via http
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id: audio_decoder_mp3_http.c 256 2009-03-31 22:59:57Z hitman_47 $
 */

#include "audio_decoder_mp3_http.h"
#include <vdr/tools.h> // DELETENULL
#include <sstream>
#include <vdr/tools.h>
#include "logdefs.h"

cHttpMp3Decoder::cHttpMp3Decoder(ISocketHandler & h)
	: HttpGetSocket(h)
{
	mo_NETBuffer = new cSimpleRingBuffer(NET_BUFFER_SIZE);
}


cHttpMp3Decoder::~cHttpMp3Decoder()
{
	if (mo_NETBuffer)
		DELETENULL(mo_NETBuffer);
}


void cHttpMp3Decoder::OnRead(void)
{
	int n = 0;
	unsigned char readBuffer[NET_READBUFFSIZE];
	unsigned char * readBuffer_Ptr;

	readBuffer_Ptr = readBuffer;

#ifdef LASTFM_DEBUG_AUDIO
	LOGDBG("cHttpMp3Decoder::OnRead: mo_NETBuffer->Available: %ld\r\n", mo_NETBuffer->Available());
	LOGDBG("cHttpMp3Decoder::OnRead: mo_NETBuffer->Free: %ld\r\n", mo_NETBuffer->Free());
#endif
	if (mo_NETBuffer->Free() > NET_READBUFFSIZE) {
		n = recv(GetSocket(), readBuffer_Ptr, NET_READBUFFSIZE, MSG_NOSIGNAL);

		if (n == 0) {
/////			SetConnected(false);
			return;
		}

		mo_NETBuffer->Put((unsigned char *)readBuffer_Ptr, n);
	}

}


unsigned long cHttpMp3Decoder::GetDataFromSource(uint8_t * data, const unsigned long count)
{
#ifdef LASTFM_DEBUG_AUDIO
	LOGDBG("cHttpMp3Decoder::GetDataFromSource: mo_NETBuffer->Free: %ld\r\n", mo_NETBuffer->Free());
#endif
	return mo_NETBuffer->Get(data, count);
}


std::string cHttpMp3Decoder::MyUseragent(void)
{
	std::stringstream buff_stream;

	buff_stream << PLUGIN_NAME << "/" << PLUGIN_VERSION;

	return buff_stream.str();
}


void cHttpMp3Decoder::OnDelete(void)
{
	SetConnected(false);
	OnContent();
}


