/*
 * audio_player.h: The audio player and control interface
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id: audio_player.h 256 2009-03-31 22:59:57Z hitman_47 $
 */

#ifndef __AUDIO_PLAYER_H
#define __AUDIO_PLAYER_H

#include <stdint.h>
#include <vdr/player.h>
#include "audio_decoder_mp3_http.h"
#include "profile.h"

class cAudioPlayer : public cPlayer, public cThread, public cProfile
{
private:
	SocketHandler h;
	cHttpMp3Decoder * httpmp3decoder;
private:
	bool m_indexTrack;
	int m_curFrame;
	int m_maxFrames;
	enum ePlayMode
	{       pmPlay=0, pmPaused, pmStopped, pmBuffered, pmNone };
	ePlayMode m_playMode;
	cFrame * mpo_readFrame, * mpo_playFrame;
	cRingBufferFrame * mpo_ringBufferFrame;
	cCondVar mo_playerCond;
	cMutex mo_playerMutex;
	void Clear(void);
	void Reset(void);
	void SetPlayMode(ePlayMode mode);
	void WaitPlayMode(ePlayMode test, bool negate, ePlayMode wait);
	void Quit(void);
protected:
	virtual void Action(void);
public:
	cAudioPlayer(void);
	virtual ~cAudioPlayer(void);
	void Play(void);
	void Pause(void);
	void Stop(void);
	void Next(void);
	virtual bool GetIndex(int & Current, int & Total, bool SnapToIFrame = false);
private:
	std::string m_nextsong;
};


#endif // __AUDIO_PLAYER_H
